#!/usr/bin/perl -w -I/usr/sausalito/perl
# $Id: config.pl,v 1.7 2001/07/14 05:38:40 mpashniak Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# Tomcat configurator
# Will DeHaan <null@sun.com>

my $tomcat_properties = '/usr/java/jakarta-tomcat/conf/tomcat.properties';

my $DEBUG = 0;
$DEBUG && warn $0.' '.`date`;

use CCE;
use Sauce::Util;

my $cce = new CCE;
$cce->connectfd();

my $oid = $cce->event_oid();
my $obj = $cce->event_object();

my @oids = $cce->find('System');
my ($ok, $java) = $cce->get($oids[0], "Java");

if($ok) {
	my $ret = Sauce::Util::editfile($tomcat_properties, *edit_policy,
		$java->{maxClients});

	unless($ret) 
	{
		$DEBUG && warn "$0 failing, editfile $tomcat_properties, ".
			$java->{maxClients}." failed.\n";
		# $cce->bye('FAIL');
		# exit(1);
	}
}
else
{
	$cce->bye('FAIL');
	exit(1);
}

$cce->bye('SUCCESS');
exit(0);

# Fin


sub edit_policy
{
        my ($in, $out, $max) = @_;
	my $maxConnect = "security.maxConnections=$max\n";
	
	while(<$in>)
	{
		if(/^security.maxConnections=\d+/) 
		{
			$DEBUG && warn "* Found: $_, using $maxConnect *\n";
			print $out $maxConnect;
		} else {
			print $out $_;
		}
	}
	return 1;
}
