#!/usr/bin/perl -w -I/usr/sausalito/perl -I.
# $Id: enableAM.pl,v 1.6 2001/06/15 17:44:10 will Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
#
use strict;
use CCE;

my $cce = new CCE;
$cce->connectfd();

# retreive object data:
my $oid = $cce->event_oid();
my $ns = $cce->event_namespace();
my $prop = $cce->event_property();
my ($ok, $newobj, $oldobj) = $cce->get($oid, $ns);

if (!$oid || !$ns ||!$prop) {
  $cce->bye('FAIL', 'Bad oid or namespace');
  exit(1);
}

my ($oldval, $newval);
$oldval = $oldobj->{$prop} ? 1 : 0;
$newval = $newobj->{$prop} ? 1 : 0;

my %nsmap = (Java => "Java", enableHttp => "Java_http", enableAjp12 => "Java_ajp12");
my $nsprop;

# only set on a real change of boolean value, not just string value
if (!($oldval eq $newval)) {
	my @oids = $cce->find("ActiveMonitor");
	# enable or disable all parts together
	foreach $nsprop (("Java", "enableAjp12")) { # We don't use Tomcat's port 8080 "enableHttp"
	    $cce->set($oids[0], $nsmap{$nsprop}, {enabled => $newval});
	}
}

$cce->bye('SUCCESS');
exit(0);
