#!/usr/bin/perl -w -I/usr/sausalito/perl
# $Id: tomcat_toggle.pl,v 1.8.2.1 2002/03/05 01:07:27 pbaltz Exp $
# Copyright 2000-2002 Sun Microsystems, Inc., All rights reserved.
# Tomcat Virtual Site Monitor
#
# Test whether any virtual sites are using Java.
# en/disable asp-apache-3000 if necessary
#
# we determine whether Java is "enabled" if any virtual site is subscribed.

my $DEBUG = 0;
$DEBUG && warn `date`."$0\n";

use CCE;
my $cce = new CCE;
$cce->connectfd();

my $object = $cce->event_object();

# Test proposed Vsite.Java state

my $oid;
my $enabled = 0;
my ($ok, $siteJsp) = $cce->get($cce->event_oid(), 'Java');

$enabled = 1 if ($siteJsp->{enabled});

# search namespace, so there is no need to get all Java namespaces
unless($enabled)
{
	my @voids = $cce->find('Vsite', { 'Java.enabled' => 1 });
	$DEBUG && warn "vsites with java: ".join(':',@voids)."\n";
	if (scalar(@voids))
	{
		$enabled = 1;
	}
}

my ($sysoid) = $cce->find("System");
$DEBUG && warn "Enable JSP? $enabled; system OID: $sysoid\n";

my ($status, $obj) = $cce->get($sysoid, "Java");

# fix chkconfig information:
if ($obj->{enabled} && !$enabled) 
{
	$DEBUG && warn "Calling CCE to disable System.Java enabled...\n";
	$ok = $cce->set($sysoid, 'Java', {'enabled' => 0});
} 
elsif (!$obj->{enabled} && $enabled) 
{
	$DEBUG && warn "Calling CCE to enable System.Java enabled...\n";
	$ok = $cce->set($sysoid, 'Java', {'enabled' => 1});
}

# do not block w/failures
$cce->bye('SUCCESS');
exit(0);

